﻿<h3 class="pop popgreen bold">Game rules</h3> 
<div id="rules"> 
    <p> 
        The following set of rules are in conjunction to the General Terms and Conditions of Travian. You should familiarize yourself with the General Terms and Conditions to verify what is allowed and what is prohibited, especially in case of an account that has been banned for a rule violation. 
        <br /> 
        <br /> 
        Inciting, manipulating, encouraging, assisting or conspiring with others to violate any of Travian Rules is impermissible. These rules apply for players that will delete their accounts or are currently deleting their accounts without exception. 
    </p> 
    <ul class="rules"> 
        <li> 
            <strong color="#2A720B">&sect;1 Password, Registration &amp; ownership</strong> 
            <br /> 
            Each player may only own and play one account per server. 
            <ul> 
                <li> 
                    <strong color="#3BAE18">&sect;1.1 Registration</strong> 
                    <br /> 
                    The e-mail address used for the registration of an account must be under the personal and exclusive control of the person who registered the account. The person owning the e-mail address currently registered for an account is considered the owner of the account, regardless of any other personal or alliance agreements. The owner of an account is fully responsible for all actions taken by the account.  
                </li> 
                <li> 
                    <strong color="#3BAE18">&sect;1.2 Password</strong> 
                    <br /> 
                    The owner of an account may not transfer the password of an account to any person playing on the same game world (server). Additionally, knowingly choosing the same password on the same game world as another person is illegal; any of these actions is considered multiaccounting, as defined in these rules. 
                    <br /> 
                    <br /> 
                    However, it is permissible to transfer the password of an account to a person or persons playing on a different game world (or not playing at all) in order to play a single account together. 
                    <br /> 
                    <br /> 
                    There is no compensation for damages done by someone knowing the password of an account. The person receiving the password is subjected to the rules of Travian as well as the General Terms and Conditions. 
                </li> 
                <li> 
                    <strong color="#3BAE18">&sect;1.3 Email changes / account transfers</strong> 
                    <br /> 
                    In order to change the email address of your account or to transfer your account to another player NOT playing on the same server, go into your account profile (/spieler.php?s=3) and fill out the new email information. 
                </li> 
                <li> 
                    <strong color="#3BAE18">&sect;1.4 Switching accounts</strong> 
                    <br /> 
                    In order to switch an account with another person on the same game world, both persons must send an e-mail message to admin@travian.com from the e-mail address currently registered to the account. The e-mail must contain the following information: 
                    <ul> 
                        <ol> 
                            <li>The game world on which the account resides</li> 
                            <li>The nickname of the account</li> 
                            <li>The e-mail address of the new owner. </li> 
                        </ol> 
                    </ul> 
                    Afterwards, both parties must request the password for their new account via the password retrieval function. 
                </li> 
            </ul> 
        </li> 
        <li> 
            <strong color="#2A720B">&sect;2 Sitting &amp; same pc usage</strong> 
            <br /> 
            <ul> 
                <li> 
                    <strong color="#3BAE18">&sect;2.1 Sitting</strong> 
                    <br /> 
                    Every player has the right to name two sitters who may play the account during the owner's absence. Sitters must play the account they are sitting to the account’s full benefit. Abuse of this function is punishable. 
                    <br /> 
                    The sitter of an account must sit the account using the ingame account sitting function. The sitter of an account may not tend to an account by logging in with the password of the account they are sitting (see &sect;1.2). 
                    <br /> 
                    There is no compensation for damages done by a sitter. Account owners are fully responsible for the actions done by the chosen sitters of their account. In the event that sitters of an account do not follow these rules and the General Terms and Conditions of Travian, both the account owner and the sitter may be held responsible and punished. 
                </li> 
                <li> 
                    <strong color="#3BAE18">&sect;2.2 Same pc usage</strong> 
                    <br /> 
                    Players using the same computer and wanting to access each  
                    other's account must use the sitter function. 
                </li> 
            </ul> 
        </li> 
        <li> 
            <strong color="#2A720B">&sect;3 Use of externals</strong> 
            <br /> 
            The game must be played with an unmodified internet browser. The use of scripts or bots which automate account actions is against the rules.  
        </li> 
        <li> 
            <strong color="#2A720B">&sect;4 Program errors</strong> 
            <br /> 
            Program errors (also called bugs) may not be used to one's benefit. Abuse can lead to a punishment of the account.  
        </li> 
        <li> 
            <strong color="#2A720B">&sect;5 Money transactions</strong> 
            <br /> 
            Any sales or purchases concerning real money regarding accounts, units, villages, resources, services or any other aspect of Travian are impermissible. The sale of Travian accounts as well as any indirect transfer (even as gifts) in connection with auction sites or other money transactions is impermissible. 
        </li> 
        <li> 
            <strong color="#2A720B">&sect;6 Netiquette</strong> 
            <br /> 
            Everyone must communicate in a polite, conversational tone. Multihunters may change inappropriate profiles and village names without warning. 
            <ol> 
                <li> 
                    Following behavior is punishable and applies to all descriptions, the account name, alliance names, village names and messages: 
                    <br /> 
                    Participation in abusive, defamatory, sexist, racist or profane language; disparaging any religion, race, nation, gender, age group, or sexual orientation; threatening a person with actions in real life. 
                    <br /> 
                    Posting or transmission of any material not suitable for  
                    underage persons. 
                    <br /> 
                    Blackmailing players in a way that violates any of Travian's rules in accordance with the General Terms and Conditions. 
                    <br /> 
                    Displaying battle reports or messages in public without consent of both concerned parties. 
                </li> 
                <li>No real world politics are allowed in names, messages and descriptions.</li> 
                <li>English is the only language tolerated in messages and descriptions. </li> 
                <li>Impersonating officials or official positions is illegal in any way.</li> 
                <li>Advertisement of any kind that has not been permitted by the Travian Team is impermissible.</li> 
            </ol> 
        </li> 
        <li> 
            <strong color="#2A720B">&sect;7 Punishments</strong> 
            <br /> 
            If there is an offence against these game rules, the Multihunters and, if necessary, the Administrators will ban the account(s) in question and decide on a proper punishment. Punishments will always exceed the gain of the violation of the rules. 
            <br /> 
            Resources, buildings, villages or troops lost during the time of suspension do not count as punishment and will not be replaced by the Travian Team. No player has the right to claim payment or replacement for Plus/Gold time lost due to suspension. 
            <br /> 
            There is no special treatment for Travian Plus/Gold users regarding the game rules neither in the time needed to deal with the case nor in the punishment. 
            <br /> 
            <br /> 
            Players may talk to the Multihunter who banned them or an Administrator either via IGM (ingame message) or e-mail. Bans, punishments or deletions are not to be discussed in public (e.g. Chat or Forums). Appeals must be written in English. 
            <br /> 
            Additionally, the Travian Team will not provide information concerning bans to any person, other than the account owner.   
            <br /> 
            <br /> 
            Multiaccounts on the speed server and multiaccounts with less than 100 population may be deleted on sight with no prior warning. 
        </li> 
        <li> 
            <strong color="#2A720B">&sect;8 Changing of rules</strong> 
            <br /> 
            The Travian Team reserves the right to change the rules at any time. 
        </li> 
        <li> 
            <strong color="#2A720B">&sect;9 Correction clause</strong> 
            <br /> 
            If individual regulations of this set of rules should prove to be in any way ineffective, it does not affect the validity of the remaining regulations of this set of rules. The Administrators commit themselves to replace ineffective regulations with new regulations which replace the ineffective regulations as fast as possible. 
        </li> 
    </ul> 
</div>